/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#ifndef mozilla_dom_MediaTrackConstraintSetBinding_h
#define mozilla_dom_MediaTrackConstraintSetBinding_h

#include "ConstraintsBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/UnionTypes.h"

namespace mozilla {
namespace dom {

struct ConstrainDoubleRange;
struct ConstrainLongRange;
struct MediaTrackConstraintSetAtoms;
struct NativePropertyHooks;
class OwningStringOrStringSequence;
class ProtoAndIfaceCache;
class StringOrStringSequence;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

enum class SupportedVideoConstraints : uint32_t {
  Other,
  FacingMode,
  Width,
  Height,
  FrameRate,
  MediaSource,
  BrowserWindow,
  ScrollWithPage,
  EndGuard_
};

namespace SupportedVideoConstraintsValues {
extern const EnumEntry strings[9];
} // namespace SupportedVideoConstraintsValues


enum class SupportedAudioConstraints : uint32_t {
  Other,
  EndGuard_
};

namespace SupportedAudioConstraintsValues {
extern const EnumEntry strings[2];
} // namespace SupportedAudioConstraintsValues


struct MediaTrackConstraintSet : public DictionaryBase
{
  Optional<int64_t> mBrowserWindow;
  Optional<OwningStringOrStringSequence> mFacingMode;
  ConstrainDoubleRange mFrameRate;
  ConstrainLongRange mHeight;
  nsString mMediaSource;
  Optional<bool> mScrollWithPage;
  ConstrainLongRange mWidth;

  MediaTrackConstraintSet();

  explicit inline MediaTrackConstraintSet(const FastDictionaryInitializer& )
    : mFrameRate(FastDictionaryInitializer()),
      mHeight(FastDictionaryInitializer()),
      mWidth(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline MediaTrackConstraintSet(const MediaTrackConstraintSet& aOther)
    : mFrameRate(FastDictionaryInitializer()),
      mHeight(FastDictionaryInitializer()),
      mWidth(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  void
  operator=(const MediaTrackConstraintSet& aOther);

private:
  static bool
  InitIds(JSContext* cx, MediaTrackConstraintSetAtoms* atomsCache);
};

namespace binding_detail {
struct FastMediaTrackConstraintSet : public MediaTrackConstraintSet
{
  inline FastMediaTrackConstraintSet()
    : MediaTrackConstraintSet(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_MediaTrackConstraintSetBinding_h
